Attribute VB_Name = "Module1"
Option Explicit
Public Declare Function INIWRITE Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Public Declare Function INIGET Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Public Declare Function EnumWindows& Lib "user32" (ByVal lpEnumFunc As Long, ByVal lParam As Long)
Public Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Public Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" (ByVal hwnd As Long) As Long
Public Declare Function IsWindowVisible& Lib "user32" (ByVal hwnd As Long)
Public Declare Function GetParent& Lib "user32" (ByVal hwnd As Long)
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function SendMessageLong& Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long)
Public Declare Function SendMessageByString Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long
Public Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Public Declare Function FindWindowEx Lib "user32" Alias "FindWindowExA" (ByVal hWnd1 As Long, ByVal hWnd2 As Long, ByVal lpsz1 As String, ByVal lpsz2 As String) As Long
Private Declare Function SendMessageSTRING Lib "user32" Alias "SendMessageW" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long

Public Declare Function EnableWindow Lib "user32" (ByVal hwnd As Long, ByVal fEnable As Long) As Long

Public Const EM_SETSEL = 177
Public Const EM_GETSEL = 176
Public Const WM_CUT = 768
Public Const WM_PASTE = 770

Public Const WM_GETTEXTLENGTH = &HE
Public Const WM_LBUTTONDOWN = &H201
Public Const WM_LBUTTONUP = &H202
Public Const WM_SETTEXT = &HC
Public Const WM_GETTEXT = &HD
Private Const WM_KEYDOWN = &H100
Private Const HTCAPTION = 2
Dim sPattern As String, hFind As Long
Public Const GW_Child As Long = 5
Private Const GW_HWNDNEXT = 2
Sub RoomSend(Text As String)
    Dim iHnd As Long
        Dim parent, child, alt As Long
        Dim start_pos&, end_pos&, txt_len&
       'iHnd = getPalSubForm(Form1.WindowClass, Form1.Combo1.Text, Form1.RoomOutboundTextBoxClass, Form1.SendTxtIndex)
        On Error Resume Next
    parent = FindWindow("DlgGroupChat Window Class", Form1.Combo1.Text)
    child = FindWindowEx(parent, 0, "SplitterWindowEx", vbNullString)
    child = FindWindowEx(child, 0, "SplitterWindowEx", vbNullString)
    child = FindWindowEx(child, 0, "SplitterWindowEx", vbNullString)
    child = FindWindowEx(child, 0, "SplitterWindowEx", vbNullString)
    alt = GetWindow(child, GW_Child)
    alt = GetWindow(alt, GW_HWNDNEXT)
    alt = FindWindowEx(alt, 0, "atlaxwin90", vbNullString)
    alt = FindWindowEx(alt, 0, "#32770", vbNullString)
    iHnd = FindWindowEx(alt, 0, "richedit20w", vbNullString)
    iHnd = FindWindowEx(alt, iHnd, "richedit20w", vbNullString)
    txt_len& = SendMessage(iHnd, WM_GETTEXTLENGTH, 0, 0)
        'Copy Text that has been typed in if any
        If txt_len& > 0 Then ' don't need all this if user not typing
            'disable editing, may not be needed
            Call EnableWindow(iHnd, 0)
            ' save user selection / cursor position
            Call SendMessage(iHnd, EM_GETSEL, ByVal VarPtr(start_pos&), ByVal VarPtr(end_pos&))
            ' select all text and cut
            Call SendMessage(iHnd, EM_SETSEL, 0, ByVal txt_len&)
            Call SendMessage(iHnd, WM_CUT, 0, 0)
        End If
    Call SendMessageSTRING(iHnd, WM_SETTEXT, 0&, Text$)
    Call SendMessageLong(iHnd, WM_KEYDOWN, 13, 0&)
            'Send any typing back to box
        If txt_len& > 0 Then
            ' text box is empty, paste saved text
            Call SendMessage(iHnd, WM_PASTE, 0, 0)
            ' restore selection / cursor position
            Call SendMessage(iHnd, EM_SETSEL, start_pos&, ByVal end_pos&)
            'enable editing
            Call EnableWindow(iHnd, 1)
        End If
End Sub
    
Private Function getPalSubForm(ByVal TargetWinClass As String, _
    ByVal TargetWinCaption As String, ByVal TargetSubClass As String, _
    ByVal TargetSubClassIndex As Integer) As Long
    'set variables in module
    mTargetWinClass = TargetWinClass
    mTargetWinCaption = TargetWinCaption
    mTargetSubClass = TargetSubClass
    mTargetSubClassIndex = TargetSubClassIndex
    'set variables for EnumWindows function
    Dim lRet As Long
    Dim lParam As Long
    'Enum sub windows to get hnd for target
    lRet = EnumWindows(AddressOf FindSubWinds, lParam)
    'return target hnd
    getPalSubForm = mSubFormHnd
End Function
